// ---------------------------------------------------------------------------
// [Filename here]
// 
// Written by:   
// Last Updated:
//
// Description
// [write something here]
//
// ---------------------------------------------------------------------------
#include <iostream>
#include "DynArray.h"

using namespace std;


// ---------------------------------------------------------------------------
// Constructors
// Postconditions: an empty vector with size = 5  and a specified capacity.
//
// Function provided for you - no changes needed
// ---------------------------------------------------------------------------
DynArray::DynArray(int capacity)
{
	// Initialize three data members
	m_size = 0;
	m_capacity = capacity;
	mp_array = NULL;
	
	// Use growArray to set capacity and initialize array, but no elements to copy.
	growArray(m_capacity, false);
	
	// Initialize all to zero
	for(int i=0; i < m_capacity; i++)
	{
		mp_array[i] = 0;
	}
}

// ---------------------------------------------------------------------------
// Copy Constructor
// ---------------------------------------------------------------------------
DynArray::DynArray(const DynArray& a)
{
	// add the correct code here and delete this comment line
}
	
// ---------------------------------------------------------------------------
// Destructor
// ---------------------------------------------------------------------------
DynArray::~DynArray()
{
	// cout << "Array has been deleted!" << endl; // may be useful for debugging
	
	delete [] mp_array;   //<-- is this right?
	//delete mp_array;     //<-- or should it be this?  you make the call
	
}



// Insert other functions here

// ---------------------------------------------------------------------------
// Assignment operator=
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
// out stream operator<<
// ---------------------------------------------------------------------------


// ---------------------------------------------------------------------------
// Equality comparison operator==
// ---------------------------------------------------------------------------



// ---------------------------------------------------------------------------
// get
// [write a description here]
// ---------------------------------------------------------------------------
int DynArray::get(int index) const
{
	return mp_array[index];
}

// .... other functions .... you must fill in .... see header for full list



// ---------------------------------------------------------------------------
// printVector
// Written for you to assist in debugging
// Use for that purpose
// No changes needed (if you change it, change it back before submitting)
// ---------------------------------------------------------------------------
void DynArray::printVector() const
{
	cout << "Size is "<<m_size<<" capacity is "<<m_capacity<<endl;
	
	if (mp_array != NULL)
	{
		cout<<"Elements are: "<<endl;
		//for(int i=1; i <= m_size; i++)    // this may also be useful from time to time
		for(int i=1; i <= m_capacity; i++) // <-- originally capacity for-loop is active
		{
			cout << mp_array[i-1] << " ";
			if ( i % 10 ==0)
			{
				cout << endl;
			}
		} // end for
	} // end if not null
	
	cout << endl << endl;
}

// ---------------------------------------------------------------------------
// growArray 
// - private function provided for you, NO alterations should be needed
// - study it, learn it, understand it, use it correctly
// ---------------------------------------------------------------------------
void DynArray::growArray(int n, bool copy)
{
	// Declare int pointer newArr to a new array of n elements
	int* newArr = new int[n];
	
	// Throw an exception if memory not allocated
	if (NULL == newArr)
	{
		throw memoryAllocationError("memory allocation failure in growArray");
	}
	
	// if copy is true, loop to copy elements in mp_array to newArr array
	if (true == copy)
	{
		for(int i=0; i < m_size; i++)
		{
			newArr[i] = mp_array[i];
		}
	}
	
	// free memory used by mp_array
	delete [] mp_array;
	
	// Assign newArr to mp_array and Update capacity to n
	mp_array = newArr;
	m_capacity = n;

}

// ---------------------------------------------------------------------------
// ---------------------------------------------------------------------------
// end of file
